#include "stdafx.h"

namespace sl {

void get(const XmlParser& p, std::vector<DecoderInfo>& data)
{
	if (p)
	{
		data.clear();
		p.foreach(L"item", [&](const XmlParser& item){
			DecoderInfo tmp;
			std::wstring id;
			item.get(L"enable", tmp.enable);
			item.get(L"name", tmp.name);
			item.get(L"id", id);

			GUID guid = {};
			CLSIDFromString(id.c_str(), &guid);
			tmp.id = guid;

			data.push_back(tmp);
		});
	}
}

void get(const XmlParser& root, DetailConfig& detail)
{
	auto p = root.get(L"detail");

	p = root.get(L"detail.network");
	p.get(L"stop", detail.network.stop);

	p = root.get(L"detail.network.connect");
	p.get(L"timeout", detail.network.connect.timeout);
	p.get(L"count", detail.network.connect.count);
	p.get(L"wait", detail.network.connect.wait);
	p.get(L"stop", detail.network.connect.stop);

	p = root.get(L"detail.network.reconnect");
	p.get(L"interval", detail.network.reconnect.interval);

	p = root.get(L"detail.network.relay.manual");
	p.get(L"reconnect", detail.network.relay.manual.reconnect);
	p.get(L"stop", detail.network.relay.manual.stop);

	p = root.get(L"detail.network.relay.automatic");
	p.get(L"reconnect", detail.network.relay.automatic.reconnect);
	p.get(L"stop", detail.network.relay.automatic.stop);

	p = root.get(L"detail.network.rebuild");
	p.get(L"wait", detail.network.rebuild.wait);

	p = root.get(L"detail.network.reader");
	p.get(L"userAgent", detail.network.reader.userAgent);
	p.get(L"timeout", detail.network.reader.timeout);

	p = root.get(L"detail.type.flv");
	p.get(L"loop", detail.type.flv.loop);
	p.get(L"keyframe", detail.type.flv.keyframe);
	p.get(L"timestamp", detail.type.flv.timestamp);
	p.get(L"buffer", detail.type.flv.buffer);
	p.get(L"optimize", detail.type.flv.optimize);

	p = root.get(L"detail.decoder");
	p.get(L"dxva2", detail.decoder.dxva2);

	p = root.get(L"detail.video");
	get(p, detail.video);

	p = root.get(L"detail.audio");
	get(p, detail.audio);

	p = root.get(L"detail.browser");
	p.get(L"def", detail.browser.def);
	p.get(L"web", detail.browser.web);
	p.get(L"bbs", detail.browser.bbs);

	p = root.get(L"detail.snapshot");
	p.get(L"folder", detail.snapshot.folder);
	p.get(L"format", detail.snapshot.format);
	p.get(L"jpegQuality", detail.snapshot.jpegQuality);
	p.get(L"display", detail.snapshot.display);
	p.get(L"fit", detail.snapshot.fit);

	p = root.get(L"detail.board");
	p.get(L"contact", detail.board.contact);
	p.get(L"change", detail.board.change);
	p.get(L"userAgent", detail.board.userAgent);
	p.get(L"timeout", detail.board.timeout);
	p.get(L"shitaraba", detail.board.shitaraba);
	p.get(L"reload", detail.board.reload);
	p.get(L"interval", detail.board.interval);
	p.get(L"retry", detail.board.retry);
	p.get(L"thread", detail.board.thread);
	p.get(L"board", detail.board.board);
	p.get(L"move", detail.board.move);
	p.get(L"res", detail.board.res);
	p.get(L"delay", detail.board.delay);
	p.get(L"position", detail.board.position);

	p = root.get(L"detail.board.url");
	get(p, detail.board.url);

	p = root.get(L"detail.board.message");
	get(p, detail.board.message);
	
	p = root.get(L"detail.start");
	p.get(L"recent", detail.start.recent);

	p = root.get(L"detail.end");
	p.get(L"pos", detail.end.pos);
	p.get(L"size", detail.end.size);
	p.get(L"aspect", detail.end.aspect);
	p.get(L"volume", detail.end.volume);
	p.get(L"balance", detail.end.balance);
	p.get(L"mute", detail.end.mute);
}

} // namespace sl
